camera={}
camera.x=100
camera.y=100
camera.xsize=love.graphics.getWidth()
camera.ysize=love.graphics.getHeight()

function love.load()
	local rawmap = love.filesystem.load("map01.lua")() --find a better way to do this... why is dofile not working?
	map = mapI.mountLMap(rawmap)
end

function love.update(dt)
	if love.keyboard.isDown( "left" ) then
		camera.x=camera.x-dt
	elseif love.keyboard.isDown( "right" ) then
		camera.x=camera.x+dt
	end
	if love.keyboard.isDown( "up" ) then
		camera.y=camera.y-dt
	elseif love.keyboard.isDown( "down" ) then
		camera.y=camera.y+dt
	end
end

function love.draw()
	for z, layer in pairs(map.layer) do
		draw.layer(layer,z)
	end
end

draw={}
function draw.layer(layer,z)
	-- find camera view	- turn this into a seperate function?
	local xmin,ymin,xmax,ymax
	cxmin = ((camera.x - camera.xsize/2))
	cymin = ((camera.y - camera.ysize/2))
	xmin = math.floor((camera.x - camera.xsize/2)/map.data.tilewidth)
	ymin = math.floor((camera.y - camera.ysize/2)/map.data.tileheight)
	xmax = math.ceil((camera.x + camera.xsize/2)/map.data.tilewidth)
	ymax = math.ceil((camera.y + camera.ysize/2)/map.data.tileheight)
	if xmin < 1 then xmin = 1 end
	if ymin < 1 then ymin = 1 end
	if xmax > map.data.width then xmax = map.data.width end
	if ymax > map.data.height then ymax = map.data.height end
	-- todo: find matching layer-xy coordinates in accordance to parallax
	-- draw all tiles visible to the camera
	for x=xmin,xmax do
		for y=ymin,ymax do
			if layer[x][y] ~= 0 then
				love.graphics.drawq( map.atlas[map.tile[layer[x][y]].img], map.tile[layer[x][y]].quad, (x-1)*map.data.tilewidth-cxmin, (y-1)*map.data.tileheight-cymin )
			end
		end
	end
end

mapI={}
function mapI.mountLMap(rawMap)
	local map = {}
	map.tile = {}	-- the tile id list stores  tiles by ID with their respective sheet image from the atlas and the quad information to extract them
	map.atlas = {}	-- the tile texture atlas stores the sprite sheet images by ID so that they can be used with quads
	-- nothing to do with these yet - might be needed for extracting object data
	map.layer = rawMap.tileLayers	-- layer tile ID information
	map.collp = rawMap.collShapes	-- collision polygons
	map.data = rawMap.properties	-- collision polygons
	
	local atlasID = 1
	for firstID, tileSheet in pairs(rawMap.tileSheets) do
		map.atlas[atlasID] = love.graphics.newImage( tileSheet.sheetImage )
		local curID, x, y, tileHeight, tileWidth, imHeight, imWidth = 0, 1, 1, tileSheet.tileWidth, tileSheet.tileHeight, map.atlas[atlasID]:getHeight(), map.atlas[atlasID]:getWidth()
		while curID < ( imWidth*imHeight/(tileWidth*tileHeight) ) do
			map.tile[firstID+curID] = {}
			map.tile[firstID+curID].img = atlasID
			map.tile[firstID+curID].quad = love.graphics.newQuad( (x-1)*tileWidth, (y-1)*tileHeight, tileWidth, tileHeight, imHeight, imWidth )	-- quad image coordinates start at 0:0 !!!
			curID=curID+1
			x=x+1
			if x > ( imWidth/tileWidth ) then
				x=1
				y=y+1
			end
		end
		atlasID = atlasID+1
	end
	return map
end